import type { Language, VueCompilerOptions } from '@vue/language-core';
import type * as ts from 'typescript';
export interface Request {
    type: 'projectInfoForFile' | 'collectExtractProps' | 'getImportPathForFile' | 'getPropertiesAtLocation' | 'getQuickInfoAtPosition' | 'getComponentProps' | 'getComponentEvents' | 'getTemplateContextProps' | 'getComponentNames' | 'getElementAttrs';
    args: [fileName: string, ...rest: any];
}
export declare function startNamedPipeServer(ts: typeof import('typescript'), serverKind: ts.server.ProjectKind, currentDirectory: string): void;
export declare const projects: Map<ts.server.Project, {
    info: ts.server.PluginCreateInfo;
    language: Language<string>;
    vueOptions: VueCompilerOptions;
}>;
